"use strict";
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var ItemId_1 = require("./ItemId");
var ComplexPropertyCollection_1 = require("./ComplexPropertyCollection");
/**
 * Represents a collection of item Ids.
 *
 * @sealed
 */
var ItemIdCollection = (function (_super) {
    __extends(ItemIdCollection, _super);
    /**
     * @internal Initializes a new instance of the **ItemIdCollection** class.
     */
    function ItemIdCollection() {
        _super.call(this);
    }
    /**
     * @internal Creates the complex property.
     *
     * @param   {string}    xmlElementName   Name of the XML element.
     * @return  {ItemId}    ItemId.
     */
    ItemIdCollection.prototype.CreateComplexProperty = function (xmlElementName) {
        return new ItemId_1.ItemId();
    };
    /**
     * @internal Creates the default complex property.
     *
     * @return  {ItemId}      ItemId.
     */
    ItemIdCollection.prototype.CreateDefaultComplexProperty = function () {
        return new ItemId_1.ItemId();
    };
    /**
     * @internal Gets the name of the collection item XML element.
     *
     * @param   {ItemId}   complexProperty   The complex property.
     * @return  {string}                     XML element name.
     */
    ItemIdCollection.prototype.GetCollectionItemXmlElementName = function (complexProperty) {
        return complexProperty.GetXmlElementName();
    };
    return ItemIdCollection;
}(ComplexPropertyCollection_1.ComplexPropertyCollection));
exports.ItemIdCollection = ItemIdCollection;
